%define distname spring_%{version}

%define Werror_cflags %nil

Summary:	Realtime strategy game (inspired by Total Annihilation)
Name:		spring
Version:	94.1
Release:	%mkrel 5
Source0:	http://downloads.sourceforge.net/springrts/%{name}_%{version}_src.tar.lzma
# use system font:
Patch1:		spring-94.1-font.patch
Patch2:		spring-94.1-link.patch
License:	GPLv2+
Group:		Games/Strategy
URL:		http://springrts.com
BuildRequires:	SDL-devel
BuildRequires:	boost-devel
BuildRequires:	allegro-devel
BuildRequires:	desktop-file-utils
BuildRequires:	devil-devel
BuildRequires:	freetype2-devel
BuildRequires:	glew-devel
BuildRequires:	mesaglu-devel
BuildRequires:	openal-devel
BuildRequires:	libogg-devel
BuildRequires:	libvorbis-devel
BuildRequires:	libxcursor-devel
BuildRequires:	python-devel
BuildRequires:	cmake
BuildRequires:	zip
BuildRequires:	p7zip
BuildRequires:	zlib-devel
BuildRequires:	xsltproc
BuildRequires:	docbook-style-xsl
BuildRequires:	asciidoc
BuildRequires:	java-rpmbuild
BuildRequires:	icoutils
BuildRequires:	libgomp-devel
BuildRequires:	curl-devel
BuildRequires:	maven
Obsoletes:	%{name}-data < 0.75
Requires:	fonts-ttf-freefont
# Some mod is required, this is the one that was shipped with
# spring-data:
Suggests:	spring-mod-nanoblobs
# Some map is required, these are the default maps from the
# installer:
Suggests:	spring-maps-default
# Internet lobby and springsettings:
Suggests:	springlobby

%description
Spring is a 3D realtime strategy game. It was inspired by Total
Annihilation and has the same features Total Annihilation had, and
more.

%prep
%setup -qn %{name}_%{version}
%apply_patches

cat > README.install.urpmi <<EOF
If you want to install additional mods and maps that are not available as
Mageia packages, you can install them inside your homedir in subdirectories
.spring/maps and .spring/mods.
EOF


  sed -i "s/FE_DFL_ENV/FE_DFL_ENV_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp rts/lib/streflop/SMath.cpp
  sed -i "s/FE_INVALID/FE_INVALID_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DENORMAL/FE_DENORMAL_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DIVBYZERO/FE_DIVBYZERO_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_OVERFLOW/FE_OVERFLOW_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_UNDERFLOW/FE_UNDERFLOW_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_INEXACT/FE_INEXACT_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_ALL_EXCEPT/FE_ALL_EXCEPT_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_DOWNWARD/FE_DOWNWARD_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_TONEAREST/FE_TONEAREST_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_TOWARDZERO/FE_TOWARDZERO_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/FE_UPWARD/FE_UPWARD_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp
  sed -i "s/feclearexcept/feclearexcept_/g" rts/lib/streflop/FPUSettings.h rts/System/Sync/FPUCheck.cpp rts/System/myMath.cpp rts/Lua/LuaParser.cpp

%build
export CFLAGS="%optflags -fpermissive"
export CXXFLAGS="%optflags -fpermissive"
export LDFLAGS="-ldl"
%cmake -DBINDIR=%{_gamesbindir} -DLIBDIR=%{_lib}/%{name} -DJAVA_INCLUDE_PATH=%{java_home}/include -DJAVA_INCLUDE_PATH2=%{java_home}/include/linux -DJAVA_AWT_INCLUDE_PATH=%{java_home}/include
%make

%install
%makeinstall_std -C build

# Nanar:
# need by spring dedicated server
# it is not installed 

mkdir -p %{buildroot}%{_libdir}/

rm -fr %{buildroot}%{_datadir}/doc %{buildroot}%{_gamesdatadir}/spring/fonts/FreeSansBold.otf

install -m755 \
    build/libspringserver.so \
    %{buildroot}%{_libdir}/libspringserver.so

mkdir -p %{buildroot}/%{_iconsdir}/hicolor/{32x32,64x64,128x128,256x256}/apps
cd rts
icotool -x %{name}.new.ico
mv %{name}*32x32*.png %{name}.png
install -m 644 %{name}.png %buildroot%_iconsdir/hicolor/32x32/apps/%{name}.png
mv %{name}*64x64*.png %{name}.png
install -m 644 %{name}.png %buildroot%_iconsdir/hicolor/64x64/apps/%{name}.png
mv %{name}*128x128*.png %{name}.png
install -m 644 %{name}.png %buildroot%_iconsdir/hicolor/128x128/apps/%{name}.png
mv %{name}*256x256*.png %{name}.png
install -m 644 %{name}.png %buildroot%_iconsdir/hicolor/256x256/apps/%{name}.png

perl -pi -e 's|^Exec=.*|Exec=%{_gamesbindir}/%{name}|' %{buildroot}%{_datadir}/applications/%{name}.desktop
perl -pi -e 's|true|false|' %{buildroot}%{_datadir}/applications/%{name}.desktop
desktop-file-install \
  --vendor="" \
  --remove-category="Application" \
  --dir %{buildroot}%{_datadir}/applications %{buildroot}%{_datadir}/applications/%{name}.desktop


install -d -m755 %{buildroot}%{_sysconfdir}/%{name}
echo '$HOME/.spring' > %{buildroot}%{_sysconfdir}/%{name}/datadir
echo '%{_gamesdatadir}/%{name}' >> %{buildroot}%{_sysconfdir}/%{name}/datadir

install -d -m755 %{buildroot}%{_gamesdatadir}/%{name}/{mods,maps}

rm -rf %{buildroot}%{_datadir}/pixmaps/*.png

%files
%doc README.install.urpmi
%{_sysconfdir}/%{name}
%{_gamesbindir}/*
%{_gamesdatadir}/%{name}
%{_iconsdir}/hicolor/*/apps/%{name}.*
%{_datadir}/applications/%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_libdir}/%{name}
%{_libdir}/libspringserver.so
%{_mandir}/man*/spring*


%changelog
* Sun Jul 28 2013 fwang <fwang> 94.1-5.mga4
+ Revision: 459699
- rebuild for new glew

* Wed Jul 10 2013 fwang <fwang> 94.1-4.mga4
+ Revision: 452535
- rebuild for new boost

* Wed Jun 12 2013 fwang <fwang> 94.1-3.mga4
+ Revision: 442067
- mor static lib

* Wed Jun 12 2013 fwang <fwang> 94.1-2.mga4
+ Revision: 442048
- more static lib
- fix linkage
- add more br

* Wed Jun 12 2013 fwang <fwang> 94.1-1.mga4
+ Revision: 442036
- rediff patches
- new version 94.1

* Wed Apr 10 2013 barjac <barjac> 91.0-6.mga3
+ Revision: 409456
- rebuild for boost-1.53

* Mon Jan 14 2013 umeabot <umeabot> 91.0-5.mga3
+ Revision: 382527
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 20 2012 fwang <fwang> 91.0-4.mga3
+ Revision: 333105
- rebuild for new boost

* Sat Dec 01 2012 neoclust <neoclust> 91.0-3.mga3
+ Revision: 323585
- Rediff P3
- New version 91.0

* Thu Aug 30 2012 fwang <fwang> 89.0-3.mga3
+ Revision: 285671
- rebuild for new glew

* Sat Aug 04 2012 fwang <fwang> 89.0-2.mga3
+ Revision: 278358
- fix build with boost 1.50
- rebuild for new boost

* Mon Jul 16 2012 nanardon <nanardon> 89.0-1.mga3
+ Revision: 271538
- 0.89

* Wed Jun 27 2012 dams <dams> 88.0-2.mga3
+ Revision: 264472
- replace Mandriva with Mageia in README.install.urpmi
- update icon size to improve GNOME3 experience
- fix .desktop to have the entry menu to be displayed

* Wed Jun 27 2012 nanardon <nanardon> 88.0-1.mga3
+ Revision: 264364
- fix build with gcc-4.7
- 88.0

* Wed May 30 2012 kamil <kamil> 85.0-2.mga3
+ Revision: 249754
- rebuild against boost 1.49.0

* Wed Feb 08 2012 nanardon <nanardon> 85.0-1.mga2
+ Revision: 206460
- 0.85

* Mon Dec 05 2011 fwang <fwang> 84.0-1.mga2
+ Revision: 176797
- fix file list
- add archlinux patch to get it build
- new version 84.0
- rebuild for new boost

* Thu Nov 03 2011 mikala <mikala> 0.82.7.1-4.mga2
+ Revision: 162000
- Add patch2 from fedora to fix java build

  + fwang <fwang>
    - rebuild for new glew
    - rebuild for new boost

* Wed Jun 22 2011 fwang <fwang> 0.82.7.1-2.mga2
+ Revision: 111987
- rebuild for new boost

* Sat Mar 12 2011 nanardon <nanardon> 0.82.7.1-1.mga1
+ Revision: 69664
- 0.82.7.1

* Mon Mar 07 2011 nanardon <nanardon> 0.82.6.1-1.mga1
+ Revision: 65818
- mdv cleanup
- imported package spring

